package ccws2024.workshop1.view.managedbeans;

import java.io.Serializable;
import java.util.List;

import org.eclnt.editor.annotations.CCGenClass;
import org.eclnt.jsfserver.defaultscreens.OKPopup;
import org.eclnt.jsfserver.elements.impl.FIXGRIDItem;
import org.eclnt.jsfserver.elements.impl.FIXGRIDListBinding;
import org.eclnt.jsfserver.pagebean.PageBean;

import ccws2024.workshop1.logic.DOPerson;
import ccws2024.workshop1.logic.Logic;

@CCGenClass (expressionBase="#{d.PersongridUI}")

public class PersongridUI
    extends PageBean 
    implements Serializable
{
    PersondetailUI m_detailUI = new PersondetailUI();
    public PersondetailUI getDetailUI() { return m_detailUI; }

    public void onNewItemAction(javax.faces.event.ActionEvent event) 
    {
        m_detailUI.getPerson().setFirstName("Harry");
//        GridItem gi = new GridItem();
//        gi.setFirstName("First New");
//        gi.setLastName("Last New");
//        m_grid.getItems().add(0,gi);
//        m_grid.getItems().get(5).setLastName("Harry");
    }

    public PersongridUI()
    {
        List<DOPerson> ps = Logic.readAllPersons();
        for (DOPerson p: ps)
        {
            GridItem gi = new GridItem(p);
            m_grid.getItems().add(gi);
        }
    }

    FIXGRIDListBinding<GridItem> m_grid = new FIXGRIDListBinding<GridItem>();
    public FIXGRIDListBinding<GridItem> getGrid() { return m_grid; }

    public class GridItem extends FIXGRIDItem implements java.io.Serializable
    {    
        DOPerson i_person;
        public GridItem(DOPerson person)
        {
            i_person = person;
        }
        public DOPerson getPerson()
        {
            return i_person;
        }
        public void onRemoveAction(javax.faces.event.ActionEvent event) 
        {
            m_grid.getItems().remove(this);
        }
        public String getCompleteName() 
        { 
            return i_person.getLastName() + ", " + i_person.getFirstName(); 
        }
//        String i_lastName;
//        public String getLastName() { return i_lastName; }
//        public void setLastName(String value) { this.i_lastName = value; }
//
//        String i_firstName;
//        public String getFirstName() { return i_firstName; }
//        public void setFirstName(String value) { this.i_firstName = value; }
//
        public void onRowSelect()
        {
            m_detailUI.prepare(i_person,new PersondetailUI.IListener()
            {
                @Override
                public void reactOnSaved(DOPerson person)
                {
                    OKPopup.createInstance("","Nun refreshe ich!!!");
                }
            });
        }
        public void onRowExecute()
        {
        }
    }

    public String getPageName() { return "/layouts/persongrid.xml"; }
    public String getRootExpressionUsedInPage() { return "#{d.PersongridUI}"; }

}
